# $Id: ArrayUtil.pm 8488 2013-11-07 10:07:11Z hurko $
# $URL: https://pong.uvt.nl/its-nettel/Netwerken/Procedures/libuvt-noc-perl/lib/UvT/NOC/Util/ArrayUtil.pm $

use utf8;
use strict;
use warnings FATAL => 'all';

package UvT::NOC::Util::ArrayUtil;

use Exporter qw(import);
use Data::Dumper;

our @EXPORT = qw(uniq remove containsString);
our @EXPORT_OK = @EXPORT;

# remove duplicate array entries
sub uniq
{
    return sort keys %{{ map { $_ => 1 } @_ }};
}

# remove element from referenced array
sub remove
{
	my ($array_ref, $element) = @_;

	my $index = 0;
	while ($index <= @$array_ref - 1)
	{
	    my $el = @$array_ref[$index];

	    if ($el eq $element)
	    {
            splice @$array_ref, $index, 1;
	    }
	    else
	    {
            $index++;
	    }
	}
}

sub containsString
{
        my $element = shift;
        my @array = @_;

        if ( my @found = grep { $_ eq $element } @array )
        {
                return 1;
        }
        else
        {
                return 0;
        }
}

1;
